namespace CMSMicroservice.Application.ProductImagesCQ.Commands.UpdateProductImages;
public class UpdateProductImagesCommandValidator : AbstractValidator<UpdateProductImagesCommand>
{
    public UpdateProductImagesCommandValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
        RuleFor(model => model.Title)
            .NotEmpty();
        RuleFor(model => model.ImagePath)
            .NotEmpty();
        RuleFor(model => model.ImageThumbnailPath)
            .NotEmpty();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<UpdateProductImagesCommand>.CreateWithOptions((UpdateProductImagesCommand)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
